<template>
  <div class="app-container">
    <el-form size="mini" :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" >
      <el-form-item   label="申请人" prop="applyUserName">
        <el-input
          v-model="queryParams.applyUserName"
          placeholder="申请人"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item  label="门店编码" prop="storeCode">
        <el-input
          v-model="queryParams.storeCode"
          placeholder="门店编码"
          clearable
          @keyup.enter.native="handleQuery"
        />

      </el-form-item>
      <el-form-item  label="门店名称" prop="storeName">
        <el-input
          v-model="queryParams.storeName"
          placeholder="门店名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item  label="流程类型" prop="itemType">
        <el-select  clearable v-model="queryParams.itemType"  placeholder="请选择流程类型"   @keyup.enter.native="handleQuery">
          <el-option
            v-for="item in activityApplyTypeOptions"
            :key="item.dictValue"
            :label="item.dictLabel"
            :value="item.dictValue">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item   label="门店类型" prop="storeCategory">
        <el-select  clearable  v-model="queryParams.storeCategory" placeholder="请选择门店类型" @keyup.enter.native="handleQuery">
          <el-option
            v-for="item in storeCategoryOptions"
            :key="item.dictValue"
            :label="item.dictLabel"
            :value="item.dictValue">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item   label="审批状态" prop="status">
        <el-select  clearable  v-model="queryParams.status" placeholder="请选择审批状态"   @keyup.enter.native="handleQuery">
          <el-option
            v-for="item in activityApplyFormOptions"
            :key="item.dictValue"
            :label="item.dictLabel"
            :value="item.dictValue">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item   label="起止时间" prop="datetimerange">
        <el-date-picker
          style="width: 200px;"
          v-model="datetimerange"
          type="daterange"
          align="right"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          value-format="yyyy-MM-dd"
          @change="datetimeRangeChange">
        </el-date-picker>
      </el-form-item>
      <el-form-item label=" ">
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="taskList" @selection-change="handleSelectionChange">
<!--      <el-table-column type="selection" width="55" align="center" />-->
      <el-table-column label="申请人" align="center" prop="applyUserName" width="150" :show-overflow-tooltip="true"/>
      <el-table-column label="门店编码" align="center" prop="storeCode" width="110"/>
      <el-table-column label="门店名称" align="center" prop="storeName" width="220"/>
      <el-table-column label="门店类型" align="center"  width="140px">
        <template slot-scope="scope">
          {{storeCategoryFormatter(scope.row,scope.column)}}
        </template>
      </el-table-column>
      <el-table-column label="流程类型" align="center" prop="itemType"  width="220">
        <template slot-scope="scope">
          <span>{{itemTypeFormat(scope.row,scope.column)}}</span>
        </template>
      </el-table-column>
      <el-table-column label="审批节点" align="center" prop="nodeName" width="120" />
      <el-table-column label="待办人" align="center" prop="todoUserName" width="100" />
      <!--      <el-table-column label="处理人" align="center" prop="handleUserName" width="150" />-->
      <el-table-column label="任务状态" align="center" prop="status" width="150" >
        <template slot-scope="scope">
          <span>{{statusFormat(scope.row,scope.column)}}</span>
        </template>
      </el-table-column>
      <el-table-column label="申请时间" align="center" prop="applyTime" width="100" >
        <template slot-scope="scope">
          <span>{{scope.row.applyTime.split(" ")[0]}}</span>
        </template>
      </el-table-column>
<!--      <el-table-column label="通知时间" align="center" prop="todoTime" width="180" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140" fixed="right">
        <template slot-scope="scope">
          <apply-after
            v-if="scope.row.isHandle"
            :row="scope.row"
            :taskId="scope.row.taskId"
            :type="scope.row.isHandle"
            @getList="getList"
          ></apply-after>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
  import request from '@/utils/request'
  import ApplyAfter from "@/components/Activiti/ApplyAfter/index";
  import {  exportDemo } from "@/api/example/demo";
  export default {
    name: "Done",
    components: {
      ApplyAfter,
    },
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 已办表格数据
        taskList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        itemType:null,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          isHandle:"1",
          itemType: null,
          storeName: null,
          storeCode: null,
          startTime:"",
          endTime:""
        },
        storeCategoryOptions:[],
        activityApplyFormOptions:[],
        activityApplyTypeOptions:[],
        datetimerange:[],
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        },
      };
    },
    created() {
      this.getDicts("sfa_store_type").then(response => {
        this.storeCategoryOptions = response.data;
      });
      this.getDicts("activity_apply_form").then(response => {
        this.activityApplyFormOptions = response.data;
      });
      this.getDicts("activity_apply_type").then(response => {
        this.activityApplyTypeOptions = response.data;
      });
      this.getList();
    },
    methods: {
      storeCategoryFormatter(row,column){
        return this.selectDictLabel(this.storeCategoryOptions, row.storeCategory);
      },
      datetimeRangeChange(val){
        this.$forceUpdate()
        if(val == undefined || val == null){
          this.datetimerange = [];
          this.queryParams.startTime = '';
          this.queryParams.endTime = '';
        }else{
          this.queryParams.startTime = val[0];
          this.queryParams.endTime = val[1];
        }
      },
      statusFormat(row, column) {
        return this.selectDictLabel(this.activityApplyFormOptions, row.status);
      },
      itemTypeFormat(row, column) {
        return this.selectDictLabels(this.activityApplyTypeOptions, row.itemType);
      },
      /** 查询已办列表 */
      getList() {
        // if(this.itemType!=null){
        // this.queryParams.itemType=this.itemType.join(",");
        // }
        this.loading = true;
        return request({
          url: '/activiti/todoItem/list',
          method: 'get',
          params: this.queryParams
        }).then(response => {
          this.taskList = response.rows;
          this.total = response.total;
          this.loading = false;
        }).then(() => {
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          taskId: null,
          taskName: null,
        };
        this.datetimerange = [];
        this.queryParams.startTime = '';
        this.queryParams.endTime = '';
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.datetimerange = [];
        this.queryParams.startTime = '';
        this.queryParams.endTime = '';
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加已办";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getDemo(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改已办";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updateDemo(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addDemo(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除已办编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDemo(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      },
      /** 导出按钮操作 */
      // handleExport() {
      //   const queryParams = this.queryParams;
        handleExport() {
          this.download('/activiti/todoItem/export', {
            ...this.queryParams
          }, `storeCustomerSign_${new Date().getTime()}.xlsx`)
        }
        // this.$confirm('是否确认导出所有已办数据项?', "警告", {
        //   confirmButtonText: "确定",
        //   cancelButtonText: "取消",
        //   type: "warning"
        // }).then(function() {
        //   return exportDemo(queryParams);
        // }).then(response => {
        //   this.download(response.msg);
        // })
      },
    // }
  };
</script>
